<?php
/* Autor...:  */
/* Esquema.: ALM_ItemAlmacen.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Metodos de acceso a los campos de la tabla ALM_ItemAlmacen */
abstract class BaseALM_ItemAlmacenBN
{
    /* Campos de la tabla */
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_IdAlmacen;    // IdAlmacen: ( no definido )
    private $s_IdCondicion;    // IdCondicion: ( no definido )
    private $s_UbicacionFisica;    // UbicacionFisica: ( no definido )
    private $s_UbicacionFisica02;    // UbicacionFisica02: ( no definido )
    private $s_UbicacionFisica03;    // UbicacionFisica03: ( no definido )
    private $i_StockPedido;    // StockPedido: ( no definido )
    private $i_StockMinimo;    // StockMinimo: ( no definido )
    private $i_StockMaximo;    // StockMaximo: ( no definido )
    private $i_StockPuntoReorden;    // StockPuntoReorden: ( no definido )
    private $i_TiempoEspera;    // TiempoEspera: ( no definido )
    private $s_ValidacionPedidoComercialFlag;    // ValidacionPedidoComercialFlag: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo IdAlmacen */
    public function setIdAlmacen( $s_IdAlmacen )
    {
        $this->s_IdAlmacen = $s_IdAlmacen;
    }

    /* Obtiene el valor del campo IdAlmacen */
    public function getIdAlmacen()
    {
        return $this->s_IdAlmacen;
    }

    /* Establece el valor del campo IdCondicion */
    public function setIdCondicion( $s_IdCondicion )
    {
        $this->s_IdCondicion = $s_IdCondicion;
    }

    /* Obtiene el valor del campo IdCondicion */
    public function getIdCondicion()
    {
        return $this->s_IdCondicion;
    }

    /* Establece el valor del campo UbicacionFisica */
    public function setUbicacionFisica( $s_UbicacionFisica )
    {
        $this->s_UbicacionFisica = $s_UbicacionFisica;
    }

    /* Obtiene el valor del campo UbicacionFisica */
    public function getUbicacionFisica()
    {
        return $this->s_UbicacionFisica;
    }

    /* Establece el valor del campo UbicacionFisica02 */
    public function setUbicacionFisica02( $s_UbicacionFisica02 )
    {
        $this->s_UbicacionFisica02 = $s_UbicacionFisica02;
    }

    /* Obtiene el valor del campo UbicacionFisica02 */
    public function getUbicacionFisica02()
    {
        return $this->s_UbicacionFisica02;
    }

    /* Establece el valor del campo UbicacionFisica03 */
    public function setUbicacionFisica03( $s_UbicacionFisica03 )
    {
        $this->s_UbicacionFisica03 = $s_UbicacionFisica03;
    }

    /* Obtiene el valor del campo UbicacionFisica03 */
    public function getUbicacionFisica03()
    {
        return $this->s_UbicacionFisica03;
    }

    /* Establece el valor del campo StockPedido */
    public function setStockPedido( $i_StockPedido )
    {
        $this->i_StockPedido = $i_StockPedido;
    }

    /* Obtiene el valor del campo StockPedido */
    public function getStockPedido()
    {
        return $this->i_StockPedido;
    }

    /* Establece el valor del campo StockMinimo */
    public function setStockMinimo( $i_StockMinimo )
    {
        $this->i_StockMinimo = $i_StockMinimo;
    }

    /* Obtiene el valor del campo StockMinimo */
    public function getStockMinimo()
    {
        return $this->i_StockMinimo;
    }

    /* Establece el valor del campo StockMaximo */
    public function setStockMaximo( $i_StockMaximo )
    {
        $this->i_StockMaximo = $i_StockMaximo;
    }

    /* Obtiene el valor del campo StockMaximo */
    public function getStockMaximo()
    {
        return $this->i_StockMaximo;
    }

    /* Establece el valor del campo StockPuntoReorden */
    public function setStockPuntoReorden( $i_StockPuntoReorden )
    {
        $this->i_StockPuntoReorden = $i_StockPuntoReorden;
    }

    /* Obtiene el valor del campo StockPuntoReorden */
    public function getStockPuntoReorden()
    {
        return $this->i_StockPuntoReorden;
    }

    /* Establece el valor del campo TiempoEspera */
    public function setTiempoEspera( $i_TiempoEspera )
    {
        $this->i_TiempoEspera = $i_TiempoEspera;
    }

    /* Obtiene el valor del campo TiempoEspera */
    public function getTiempoEspera()
    {
        return $this->i_TiempoEspera;
    }

    /* Establece el valor del campo ValidacionPedidoComercialFlag */
    public function setValidacionPedidoComercialFlag( $s_ValidacionPedidoComercialFlag )
    {
        $this->s_ValidacionPedidoComercialFlag = $s_ValidacionPedidoComercialFlag;
    }

    /* Obtiene el valor del campo ValidacionPedidoComercialFlag */
    public function getValidacionPedidoComercialFlag()
    {
        return $this->s_ValidacionPedidoComercialFlag;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdCompania' => $this->getIdCompania(),
            'IdItem' => $this->getIdItem(),
            'IdAlmacen' => $this->getIdAlmacen(),
            'IdCondicion' => $this->getIdCondicion(),
            'UbicacionFisica' => $this->getUbicacionFisica(),
            'UbicacionFisica02' => $this->getUbicacionFisica02(),
            'UbicacionFisica03' => $this->getUbicacionFisica03(),
            'StockPedido' => $this->getStockPedido(),
            'StockMinimo' => $this->getStockMinimo(),
            'StockMaximo' => $this->getStockMaximo(),
            'StockPuntoReorden' => $this->getStockPuntoReorden(),
            'TiempoEspera' => $this->getTiempoEspera(),
            'ValidacionPedidoComercialFlag' => $this->getValidacionPedidoComercialFlag(),
            'Estado' => $this->getEstado(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_ItemAlmacenBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_ItemAlmacenRs )
    {
        $o_ALM_ItemAlmacenBN = new ALM_ItemAlmacenBN();
        $o_ALM_ItemAlmacenBN->setIdCompania( ( integer ) $o_ALM_ItemAlmacenRs[ "IdCompania" ] );
        $o_ALM_ItemAlmacenBN->setIdItem( $o_ALM_ItemAlmacenRs[ "IdItem" ] );
        $o_ALM_ItemAlmacenBN->setIdAlmacen( $o_ALM_ItemAlmacenRs[ "IdAlmacen" ] );
        $o_ALM_ItemAlmacenBN->setIdCondicion( $o_ALM_ItemAlmacenRs[ "IdCondicion" ] );
        $o_ALM_ItemAlmacenBN->setUbicacionFisica( $o_ALM_ItemAlmacenRs[ "UbicacionFisica" ] );
        $o_ALM_ItemAlmacenBN->setUbicacionFisica02( $o_ALM_ItemAlmacenRs[ "UbicacionFisica02" ] );
        $o_ALM_ItemAlmacenBN->setUbicacionFisica03( $o_ALM_ItemAlmacenRs[ "UbicacionFisica03" ] );
        $o_ALM_ItemAlmacenBN->setStockPedido( ( integer ) $o_ALM_ItemAlmacenRs[ "StockPedido" ] );
        $o_ALM_ItemAlmacenBN->setStockMinimo( ( integer ) $o_ALM_ItemAlmacenRs[ "StockMinimo" ] );
        $o_ALM_ItemAlmacenBN->setStockMaximo( ( integer ) $o_ALM_ItemAlmacenRs[ "StockMaximo" ] );
        $o_ALM_ItemAlmacenBN->setStockPuntoReorden( ( integer ) $o_ALM_ItemAlmacenRs[ "StockPuntoReorden" ] );
        $o_ALM_ItemAlmacenBN->setTiempoEspera( ( integer ) $o_ALM_ItemAlmacenRs[ "TiempoEspera" ] );
        $o_ALM_ItemAlmacenBN->setValidacionPedidoComercialFlag( $o_ALM_ItemAlmacenRs[ "ValidacionPedidoComercialFlag" ] );
        $o_ALM_ItemAlmacenBN->setEstado( $o_ALM_ItemAlmacenRs[ "Estado" ] );
        $o_ALM_ItemAlmacenBN->setUsuarioModificacion( $o_ALM_ItemAlmacenRs[ "UsuarioModificacion" ] );
        $o_ALM_ItemAlmacenBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_ItemAlmacenRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_ItemAlmacenBN->setUsuarioCreacion( $o_ALM_ItemAlmacenRs[ "UsuarioCreacion" ] );
        $o_ALM_ItemAlmacenBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_ItemAlmacenRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        return $o_ALM_ItemAlmacenBN;
    }
}
?>